### Constructor

# Camel StoreDB new

since: 3.58

#### Declaration [src]

    CamelStoreDB*
    camel_store_db_new (
      const gchar* filename,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Creates a new `CamelStoreDB` instance, which uses `filename` as its storage.

It also migrates existing data, if needed, providing feedback through the `cancellable`, if it’s a `CamelOperation` instance.

Available since: 3.58

#### Parameters

`filename`

  Type: `const gchar*`

  A file name of the database to use.

  The data is owned by the caller of the function.
  The value is a NUL terminated UTF-8 string.

`cancellable`

  Type: `GCancellable`

  A `GCancellable`, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the function.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the constructor if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `CamelStoreDB`

A new `CamelStoreDB`, or `NULL` on error.

The caller of the function takes ownership of the data, and is responsible for freeing it.